<?php
/*
Plugin Name: Indizar
Plugin URI: http://www.sebaxtian.com/acerca-de/indizar
Description: A plugin to index a post using chapters.
Version: 0.4.5
Author: Juan Sebastián Echeverry
Author URI: http://www.sebaxtian.com
*/

/*  Copyright 2008-2009  Juan Sebastián Echeverry  (email : sebaxtian@gawab.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

add_action('init', 'ind_addbuttons');
add_action('wp_head', 'ind_header');
add_action('init', 'ind_textdomain');
add_filter('query_vars', 'ind_query_var');
add_action('pre_get_posts', 'ind_get_chapter');
add_filter('the_content', 'ind_content');
add_filter('generate_rewrite_rules','ind_rewriteRules');

function ind_textdomain() {
	load_plugin_textdomain('indizar', 'wp-content/plugins/indizar/lang');
}

function ind_get_chapter($vars) {
  global $chapter;
  $chapter=1;
  if($vars->chapter)
    $chapter=$vars->chapter;
}

function ind_rewriteRules($rules){
 global $wp_rewrite;
 
	// add rewrite tokens
  $keytag = '%chapter%';
	$wp_rewrite->add_rewrite_tag($keytag, '([0-9]+)', 'chapter=');

  // rule for 'posts'
  $post_structure = $wp_rewrite->permalink_structure . "/chapter/$keytag";
  $post_structure = str_replace('//', '/', $post_structure);
  $post_rewrite = $wp_rewrite->generate_rewrite_rules($post_structure, EP_PERMALINK);

// rule for 'pages'
  /*$page_structure = $wp_rewrite->get_page_permastruct() . "/chapter/$keytag";
  $page_structure = str_replace('//', '/', $page_structure);
  $page_rewrite = $wp_rewrite->generate_rewrite_rules($page_structure);*/

	$wp_rewrite->rules = array_merge($post_rewrite, $wp_rewrite->rules);
  
	return $wp_rewrite->rules;
}

function ind_header( )
{
  echo "<link rel='stylesheet' href='".get_bloginfo('wpurl')."/wp-content/plugins/indizar/indizar.css' type='text/css' media='screen' />";
}

function ind_query_var($vars) {
  array_push($vars, 'chapter');
  return $vars;
}

function ind_prepost($title, $content) {
   global $chapters,$page,$chapter;
   
   $chapters=false;
   
   $chapters[1]=$title;
   $page_index=1;
	 
	 //serach for firstchapter
	 $search = "@(?:<p>)*\s*\[firstchapter\s*:\s*(.+)\]\s*(?:</p>)*@i";
   if  (preg_match_all($search, $content, $matches))
   {
      if (is_array($matches))
      {
         foreach ($matches[1] as $key =>$v0)
         {
            $search = $matches[0][$key];
            $replace= "<div class='indizar'>$v0</div>";
            $content= str_replace ($search, $replace, $content);
            $chapters[1]=$v0;
         }
      }
   }
   
   //search for chapter
   $search = "@(?:<p>)*\s*\[chapter\s*:\s*(.+)\]\s*(?:</p>)*@i";
   if  (preg_match_all($search, $content, $matches))
   {
      if (is_array($matches))
      {
         foreach ($matches[1] as $key =>$v0)
         {
            $search = $matches[0][$key];
            $replace= "<!--chapter--><div class='indizar'>$v0</div>";
            $content= str_replace ($search, $replace, $content);
            $page_index++;
            $chapters[$page_index]=$v0;
         }
      }
   }
   if(count($chapters)==1) 
      $chapters=false;
	
	return $content;

}

function ind_content($content)
{
   global $chapter,$chapters,$post,$page,$more;

   //search for chapters
   $index=false;
   $content = ind_prepost($post->post_title, $content);
	
	//get the list of chapters
	$list=chap_list();
	
	//Create html cdoe for the chapter index
   if($list && $more) {
      $index="<ul>";
      $chap_index=1;
		foreach($list as $item) {
         if($chapter!=$chap_index)
            $index.="<li><a href='".$item['url']."'>".$item['chapter']."</a></li>";
         else
            $index.="<li>".$item['chapter']."</li>";
         $chap_index++;
      }
      $index.="</ul>";
   }
   
   //Chapters Box without style
   $search = "@(?:<p>)*\s*\[chapters\]\s*(?:</p>)*@i";
   if  (preg_match_all($search, $content, $matches))
   {
      if (is_array($matches)) 
      {

         $search = $matches[0][0];
         $replace="";
         if($index) {
            $replace = "<div class='chapters'>".$index."</div>";
         }
         $content = str_replace ($search, $replace, $content);
      }
   }
   
   //Chapters box with style
   $search = "@(?:<p>)*\s*\[chapters\s*:\s*(\d+)(||,left|,right)\]\s*(?:</p>)*@i";
   if  (preg_match_all($search, $content, $matches))
   {
      if (is_array($matches)) 
      {

         foreach ($matches[1] as $key =>$v0)
         {
            $v1=$matches[2][$key];
            if($v1) $v1=substr($v1,1);
            $search = $matches[0][$key];
            
            $replace="";
            if($index) {
               $replace = "<div class='chapters' id='".$v1."' style='width: ".$v0."px;";
               if($v1)
                  $replace.=" float: $v1;";
   
               $replace.="'>".$index."</div>";
            }

            $content = str_replace ($search, $replace, $content);
         }
      }
   }
  if ( strpos( $content, '<!--chapter-->' ) ) {
    $content = str_replace("\n<!--chapter-->", '<!--chapter-->', $content);
    $chapters_array = explode('<!--chapter-->', $content);
    $content = $chapters_array[$chapter-1];
  }   
	
	//If there is a chapter list and we are showing the hole document, show chapters at the end
	if($list && $more) {
		$chapter_foot="<strong>".__("Chapters", 'indizar').":</strong> ";

    //Previous
    if($chapter!=1) {
      $chapter_foot.="<a href='".$list[$chapter-1]['url']."'>".__("&laquo; Previous")."</a> ";
    } else {
      $chapter_foot.=__("&laquo; Previous")." ";
    }
    
		$count=1;
		foreach($list as $item) {
			if($chapter==$count) {
				$chapter_foot.="$count ";
			} else {
				$chapter_foot.="<a href='".$item['url']."'>$count</a> ";
			}
			$count++;
		}

    //Next
    if($chapter!=$count-1) {
      $chapter_foot.="<a href='".$list[$chapter+1]['url']."'>".__("Next &raquo;")."</a>";
    } else {
      $chapter_foot.=__("Next &raquo;");
    }
    
		$content.="<p>$chapter_foot</p>";
	}
   
   return $content;
}

function chap_list() {
   global $chapters, $post;
	
	$item=false;
	
	$page_index=1;
	
	if($chapters) {
		$item=array();
		foreach($chapters as $chapter) {		
			$item[$page_index]['chapter']=$chapter;
			if ( $page_index == 1 ) {
				$item[$page_index]['url']=get_permalink();
			} else {
				if ( '' == get_option('permalink_structure') || in_array($post->post_status, array('draft', 'pending')) )
					$item[$page_index]['url']=get_permalink() . '&amp;chapter=' . $page_index;
				else
					$item[$page_index]['url']=trailingslashit(get_permalink()) . user_trailingslashit("chapter/".$page_index, 'ch');
			}
			$page_index++;
		}
	}
	
   return $item;
}

function ind_addbuttons() {
   // Don't bother doing this stuff if the current user lacks permissions
      if ( !current_user_can('edit_posts') && !current_user_can('edit_pages') ) return;

   // Add only in Rich Editor mode
        if ( get_user_option('rich_editing') == 'true') {
    
      // add the button for wp21 in a new way
         add_filter('mce_external_plugins',  'add_ind_script');
         add_filter('mce_buttons',  'add_ind_button');
      }
}

function add_ind_button($buttons) {

   array_push($buttons, 'Indizar');
   return $buttons;

}

function add_ind_script($plugins) {
   $dir_name = '/wp-content/plugins/indizar';
   $url=get_bloginfo('wpurl');
   $pluginURL =  $url.$dir_name.'/tinymce/editor_plugin.js';
   $plugins['Indizar'] = $pluginURL;
   return $plugins;
}

?>